unit Unit1;

interface

{hjksf + erjkghe + egjkh + srgjh +wrgtjerh + wjk + wrjk + rhjk + wrk + rjkt + wrk + tjkwrjkth + wrhtgt + wrhthj + whtw +wtjwrt}
{COS(MAX(MIN(1, 2) + MAX(3, MAX(4,5) * PERCENT(6,7)-MIN(8,9))*MIN(76,COS(8)), 90))}

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, RYFormulaEvaluator, Buttons, Spin;


type
  TForm1 = class(TForm)
    Edit1: TEdit;
    Edit2: TEdit;
    ScrollBox1: TScrollBox;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    Memo1: TMemo;
    SpinEdit1: TSpinEdit;
    Label2: TLabel;
    BitBtn4: TBitBtn;
    Label3: TLabel;
    CBCompilados: TCheckBox;
    ButtonThreads: TButton;
    Label1: TLabel;
    procedure ButtonVariablesClick(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure BitBtn3Click(Sender: TObject);
    procedure BitBtn4Click(Sender: TObject);
    procedure ButtonThreadsClick(Sender: TObject);
  private
    { Private declarations }
    p: TRyFormulaEval;
    oL: TList;
    Func: Integer;
    function RedeclFunc(var Values: array of Extended): Extended;
    function MyFunc(var Values: array of Extended): Extended;
    function RedeclFunc2(var Values: array of Extended): Extended;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}
uses UnitThreads;

procedure TForm1.FormCreate(Sender: TObject);
var
  l: Integer;
begin
  oL := TList.Create;

  for l := 0 to 0 do
  begin
    p := TRyFormulaEval.Create;
    p.UseStandardFunctions;
    oL.Add(p);
  end;
  p.AddFunctionDecl('MYFUNC', 1, MyFunc);
//  WORKS WITH FULL VERSION: p.AddFunctionDecl('REDECL', 5, RedeclFunc);
end;

function TForm1.RedeclFunc(var Values: array of Extended): Extended;
begin
  result := values[4] * 10000 + values[3] * 1000 + values[2] * 100 + values[1] * 10 + values[0];
end;

function TForm1.RedeclFunc2(var Values: array of Extended): Extended;
begin
  result := values[4] * 10000 + values[3] * 1000 + values[2] * 100 + values[1] * 10 + values[0] + 1;
end;

function TForm1.MyFunc(var Values: array of Extended): Extended;
begin
  result := Cos(values[0]) + 1;
end;

procedure TForm1.FormDestroy(Sender: TObject);
var
  l: Integer;
begin
  for l := 0 to oL.Count - 1 do
  begin
    p := TRyFormulaEval(oL.Items[l]);
    p.Free;
  end;

  oL.Free;
end;


procedure TForm1.ButtonVariablesClick(Sender: TObject);
var
  k: Integer;
  ed: TEdit;
  lbl: TLabel;

begin
  ScrollBox1.Visible := False;
  while ScrollBox1.ControlCount > 0 do
    ScrollBox1.Controls[0].Free;

  p.Formula := Edit1.Text;
  p.Parse;
  for k := 0 to p.VarCount - 1 do
  begin
    ed := TEdit.Create(Self);
    ed.Parent := ScrollBox1;
    ed.Left := 70;
    ed.Top := k * 30;
    ed.Width := 60;
    ed.Text := IntToStr(k + 1) + '.' + IntToStr(k + 1); 
    Lbl := TLabel.Create(Self);
    Lbl.Parent := ScrollBox1;
    Lbl.Left := 5;
    Lbl.Caption := p.VarName(k);
    Lbl.Top := k * 30;
    ed.Tag := k;
  end;
  BitBtn1.Enabled := True;
  BitBtn4.Enabled := True;
  ScrollBox1.Visible := True;
end;






procedure TForm1.BitBtn1Click(Sender: TObject);
var
  k: Integer;
  a: PVariable;
begin
  for k := 0 to ScrollBox1.ControlCount - 1 do
  begin
    if ScrollBox1.Controls[k] is TEdit then
    begin
      a := p.VarByIndex[TEdit(ScrollBox1.Controls[k]).Tag];
      a^.Value := StrToFloat(TEdit(ScrollBox1.Controls[k]).Text);
    end;
  end;
  if CBCompilados.Checked then
    Edit2.Text := FloatToStr(p.Result)
  else
    Edit2.Text := FloatToStr(p.ResultNOCompile);
  if Func xor 1 = 1 then
    //WORKS WITH FULL VERSION: p.ModifyFunctionDecl('REDECL', RedeclFunc)
  else
    ; // WORKS WITH FULL VERSION:p.ModifyFunctionDecl('REDECL', RedeclFunc2);
  Func := Func xor 1;
end;


procedure TForm1.BitBtn3Click(Sender: TObject);
var
  k: Integer;
  l: Double;
  t: Integer;
  a: PVariable;
begin
  for k := 0 to ScrollBox1.ControlCount - 1 do
  begin
    if ScrollBox1.Controls[k] is TEdit then
    begin
      a := p.VarByIndex[TEdit(ScrollBox1.Controls[k]).Tag];
      a^.Value := StrToFloat(TEdit(ScrollBox1.Controls[k]).Text);
    end;
  end;

  Windows.Beep(500, 50);
  t := GetTickCount;
  for k := 0 to SpinEdit1.Value - 1 do
  begin
    if CBCompilados.Checked then
      l := p.Result
    else
      l := p.ResultNOCompile;
    if k mod 103 = 0 then
    begin
      Label3.Caption := IntToStr(k);
      Application.ProcessMEssages;
    end;
  end;
  Label3.Caption := IntToStr(k);

  Memo1.Lines.Add('Total Time was ' + IntToStr(GetTickCount - t) + ' milliseconds');
  windows.BEep(2000, 50);
end;

procedure TForm1.BitBtn4Click(Sender: TObject);
var
  k, f: Integer;
  l: Double;
  t: Integer;
  a: PVariable;
begin
  for f := 0 to ScrollBox1.ControlCount - 1 do
  begin
    if ScrollBox1.Controls[f] is TEdit then
    begin
      a := p.VarByIndex[TEdit(ScrollBox1.Controls[f]).Tag];
      a^.Value := StrToFloat(TEdit(ScrollBox1.Controls[f]).Text);
    end;
  end;

  windows.BEep(500, 50);
  t := GetTickCount;
  for k := 0 to SpinEdit1.Value - 1 do
  begin
    if CBCompilados.Checked then
      l := p.Result
    else
      l := p.ResultNOCompile;

    a := p.VarByIndex[0];
    a^.Value := Random(50);
  end;
  Label3.Caption := IntToStr(k);
  Memo1.Lines.Add('Total time was ' + IntToStr(GetTickCount - t) + ' milliseconds');
  windows.BEep(2000, 50);
end;

procedure TForm1.ButtonThreadsClick(Sender: TObject);
begin
  Form2.ShowModal;
end;

end.

